importPackage(java.lang);
importPackage(java.util);
importPackage(java.io);
importClass(Packages.com.alarmpoint.integrationagent.config.IAConfigImpl);
importClass(Packages.com.alarmpoint.integrationagent.config.xml.IAConfigFileImpl);

/******************************************************************************/
/*        Start of xMatters Webservices Base Class Object Definition          */
/******************************************************************************/
var failedList = new ArrayList();
var successList = new ArrayList();

var xmns = new Namespace("http://www.alarmpoint.com/webservices/schema");

var xMattersWS = WSUtil.extend({

  XMATTERS_WSDL_DEFN: "integrationservices/tivoli-ccmdb/soap/AlarmPoint-soapui-project.xml",
  XM_SOAP_VERSION: "1_1",
  SERVICE_DENIED: "SERVICE_DENIED",

  IA_CONFIG_FILE_PATH: "conf/IAConfig.xml",
  
  /**
   * Constructor
   */
  init: function()
  {
    this._super(); 

    var configFile = new File(this.IA_CONFIG_FILE_PATH);
    var iaConfigFile = new IAConfigFileImpl(new FileReader(configFile));
    var iaConfig = new IAConfigImpl(iaConfigFile, configFile.getParentFile(), configFile.toURI());
    
    this.wsUser = iaConfigFile.getWSUser();
    this.wsPassword = iaConfig.getWsAuth().getPassword();
    this.wsCompany = iaConfigFile.getWSCompany();
    this.endPoint = iaConfigFile.getPrimaryServerUrls().next();
  },
  
  /**
   * Sends the request to the SOAP endpoint and returns the response
   * @param url EndPoint for the webservice request
   * @param msg SOAPMessage instance containing the SOAPEnvelope to post
   * @param objectType the type of object being synchronized (User, Coverage, Device, Group, Team)
   * @param objectName the name of the object being synchronized
   * @return SOAP Response Body
   */
  syncSendReceive: function(url, msg, objectType, objectName)
  {
    var response = this.sendReceive(url, msg);

    default xml namespace = xmns;
    var status = response..status;
    
    if (!"OK".equalsIgnoreCase(status))
    {
      failedList.add(objectType + ": " + objectName + " failed to synchronize: " + status);
    }
    else
    {
      successList.add(objectType + ": " + objectName + " synchronized: " + status);
    }
    return response;
  }
  
});
