<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:util="xalan://com.xmatters.ibm.tivoli.util.SyncUtil"
  extension-element-prefixes="util">
  <xsl:output method="xml" />

  <xsl:template match="//data">
    <xsl:apply-templates select="../data" mode="process"/>
  </xsl:template>
  
  <!--
    Create the content to be sent to the Integration Agent 
   -->
  <xsl:template match="data" mode="process">
    <!-- Default Integration Agent XML -->
    <transaction>
      <header>
        <method>
          Add
        </method>
        <subclass>
          Action
        </subclass>
      </header>
      <data>
        <!-- Add injected event parameters -->
        <xsl:choose>
          <xsl:when test="as_ownertable = 'WOCHANGE'">
            <action_script_set>tivoli-ccmdb</action_script_set>
            <agent_client_id>tivoli-ccmdb</agent_client_id>
          </xsl:when>
          <xsl:otherwise>
            <action_script_set>tivoli-ccmdb</action_script_set>
            <agent_client_id>tivoli-ccmdb</agent_client_id>
          </xsl:otherwise>
        </xsl:choose>
        <!-- Create a new event token for each element with data in the wfassignment XML -->
        <xsl:apply-templates select="node()" mode="tokens"/>
      </data>
    </transaction>
  </xsl:template>

  <!--
    Create a new event token for each element at the current parsing level that contains text
   -->
  <xsl:template match="node()" mode="tokens">
    <xsl:if test="normalize-space(text()) != ''">
      <xsl:element name="{name()}">
        <xsl:attribute name="type">string</xsl:attribute>
        <xsl:value-of select="text()" />
      </xsl:element>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
