<%@page import="com.xmatters.integrations.ws.*" %>
<%@page import="com.xmatters.ibm.tivoli.util.*" %>
<%@page import="org.dom4j.*" %>
<%@page import="java.util.*"%>
<%@page import="java.util.Map.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%@page import="psdi.server.MXServer"%>
<%@page import="psdi.iface.mic.StructureData"%>
<%@page import="psdi.mbo.MboSetRemote"%>
<%@page import="psdi.server.MXServer"%>
<%@page import="psdi.util.MXApplicationException"%>
<%@page import="psdi.util.MXException"%>
<%@page import="psdi.security.UserInfo"%>
<%@page import="psdi.mbo.MboRemote"%>
<%@page import="psdi.util.MXSession"%>

<%!
  private SyncUtil util = new SyncUtil(); // This will initialize the properties and make them available in the JSPs
  private UserInfo userInfo = null;
  private String errMsg = "This is a base error message and should be replaced by a more meaningful one.";
  
  // Declare All Methods Here
  String getValueOfNode(Node node, String xpath){
      Node targetNode = node.selectSingleNode(xpath);
      String targetValue = "";
      if(targetNode != null)
        targetValue = targetNode.getText();
        return targetValue;
  }

  List getMXObjectValues(String object, String field, Map filters){
    List values = new ArrayList();
    try{
      MboSetRemote set = MXServer.getMXServer().getMboSet(object, userInfo);
      set.setQbeExactMatch(false);
      if(filters != null){
        Iterator itr = filters.entrySet().iterator();
        while(itr.hasNext())
        {
          Entry entry = (Entry)itr.next();
          set.setQbe((String)entry.getKey(), (String)entry.getValue());
        }
      }
      set.reset();
      for(int i=0; i < set.count(); i++){
        MboRemote mboObject = set.fetchNext();
        values.add(mboObject.getString(field));
      }
      Collections.sort(values, String.CASE_INSENSITIVE_ORDER);
    }catch(Exception e){
      values.add("Exception: "+e);
    }
    return values;
  }

  boolean updateUserInfo(javax.servlet.http.HttpSession session){
    // Retrieve the current MXSession and check that it's valid
    MXSession mxSession = (MXSession)session.getAttribute("MXSession");
    if(mxSession != null){
      userInfo = mxSession.getUserInfo();
      return true;
    }else{
      errMsg = "Unable to obtain psdi.security. UserInfo reference from MXSession object";
      return false;
    }
  }

  boolean isInSecurityGroup(String optionName){
    try{
      // First retrieve Security Groups who are authorized to view this page
      MboSetRemote securityGroupSet = MXServer.getMXServer().getMboSet("APPLICATIONAUTH", userInfo);
      securityGroupSet.setQbeExactMatch(true);
			securityGroupSet.setQbe("OPTIONNAME", optionName);
      securityGroupSet.reset();
      for(int i=0; i < securityGroupSet.count(); i++){
        MboRemote securityGroup = securityGroupSet.fetchNext();
        // Next for each Security Group that is authorized check if the current user is in that group
        MboSetRemote groupUserSet = MXServer.getMXServer().getMboSet("GROUPUSER", userInfo);
        groupUserSet.setQbeExactMatch(true);
        groupUserSet.setQbe("GROUPNAME", securityGroup.getString("GROUPNAME"));
        groupUserSet.reset();
        for(int j=0; j < groupUserSet.count(); j++){
          MboRemote groupUser = groupUserSet.fetchNext();
          // If the current user is a part of the group they can view this page so return true
          if(userInfo.getPersonId().equals(groupUser.getString("USERID")))
            return true;
        }
      }
      errMsg = "Could not find user: "+userInfo.getPersonId()+" in an appropriate Security Group";
    }catch(Exception e){
      errMsg = e.getMessage();
    }
    return false;
  }
%>
<%
  // Setup AlarmPoint web service information
  AlarmPointWebServiceClient wsClient = new AlarmPointWebServiceClient(util.getApWSUrl(), util.getApWSUser(), util.getApWSPass(), util.getApWSCompany());
%>