<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%@page import="java.net.URLEncoder" %>

<% try { %>
<html>
<head>
    <link rel="stylesheet" type="text/css" href="alarmpoint.css" />
    <title>xMatters View Notifications</title>
</head>
<body>
    <h1>xMatters View Notifications</h1>
    <%@include file="Configuration.jsp"%>
    <%
    String securityOptionName = "XMVN";
    if(updateUserInfo(session) && isInSecurityGroup(securityOptionName)){
      // Setup All Variables

      SimpleDateFormat xmlFormat = new SimpleDateFormat("dd/MM/yyyy h:mm:ss a");
      SimpleDateFormat displayFormat = new SimpleDateFormat("MMMM dd, yyyy HH:mm Z");
      xmlFormat.setTimeZone(TimeZone.getTimeZone("GMT"));

      Calendar now = Calendar.getInstance();
      String operator = request.getParameter("operator");

      // Create the required Elements for the request
      Element[] elements = new Element[1];
      Element tokenElm = wsClient.createElement("searchParameters", null);
      tokenElm.add(wsClient.createElement("eventDomain", "tivoli-ccmdb"));
      tokenElm.add(wsClient.createElement("incidentId", ""));
      tokenElm.add(wsClient.createElement("owner", operator));
      elements[0] = tokenElm;

      // Make the web service request
      Node wsResponse = wsClient.send("FindActiveUserNotifications", elements);
      Node groupNode = wsResponse.selectSingleNode("ap:return");

      List notificationNodes = groupNode.selectNodes("ap:detailedPersonNotificationList/ap:detailedPersonNotification");
      if (notificationNodes.size() == 0) {
       %>
       nothing
       <%
      } else {
        %>
        <h1>Notifications for User <%=operator%></h1>
        <table class="notifications">
          <tr>
            <th>Incident ID</th>
            <th>Event ID</th>
            <th>Action</th>
            <th>Time</th>
            <th>Event Subject</th>
            <th>Event Message</th>
          </tr>
          <%

          for(int i = 0; i<notificationNodes.size(); i++)
          {
            Node notification = (Node)notificationNodes.get(i);
            String personNotificationId = getValueOfNode(notification, "ap:personNotificationId");
            String targetNameId = getValueOfNode(notification, "ap:targetNameId");
            %>
            <tr>
              <td><%=getValueOfNode(notification, "ap:incident_id")%></td>
              <td><%=getValueOfNode(notification, "ap:eventIdentifier")%></td>
              <td>
              <%
                List responseChoiceNodes = notification.selectNodes("ap:responseChoices");
                for(int j = 0; j<responseChoiceNodes.size(); j++) {
                  String responseChoice = ((Node)responseChoiceNodes.get(j)).getText();
                %>
                  <a href=<%=util.getApUrl() + "/jsp/ProcessNotificationResponse.jsp?company=" + URLEncoder.encode(util.getApWSCompany()) + "&username=" + URLEncoder.encode(operator) + "&userId=" + URLEncoder.encode(targetNameId) + "&notificationId=" + URLEncoder.encode(personNotificationId) + "&deviceType=Email&responseChoice=" + URLEncoder.encode(responseChoice)%>><%=responseChoice%></a></br>
                <%
                }
              %>
              </td>
              <td><%=getValueOfNode(notification, "ap:notificationTimestamp")%></td>
              <td><%=getValueOfNode(notification, "ap:subject")%></td>
              <td><%=getValueOfNode(notification, "ap:message")%></td>
            <tr>
            <%
          }
        %>
      </table>
    <%
      }
    }else{
    %>
      <div class="system-msg-error"><%=errMsg%></div>
    <%
    }
    %>

    <input type="submit" value="Close" onclick="javascript:{self.close();}" />
  </body>
</html>
<% } catch (Exception e) {
  e.printStackTrace(new java.io.PrintWriter(out));
}
%>
