<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<% try { %>
<html>
<head>
    <link rel="stylesheet" type="text/css" href="alarmpoint.css" /> 
    <title>xMatters Who's On Duty Report</title>
</head>
<body>
    <h1>xMatters Who's On Duty Report</h1>
    <%@include file="Configuration.jsp"%>
    <%
    String securityOptionName = "XMONDUTY";
    if(updateUserInfo(session) && isInSecurityGroup(securityOptionName)){
      // Setup All Variables
      
      SimpleDateFormat xmlFormat = new SimpleDateFormat("dd/MM/yyyy h:mm:ss a");
      SimpleDateFormat displayFormat = new SimpleDateFormat("MMMM dd, yyyy HH:mm Z");
      xmlFormat.setTimeZone(TimeZone.getTimeZone("GMT"));

      Calendar now = Calendar.getInstance();
      String group = request.getParameter("group");
      String startDate = xmlFormat.format(now.getTime());//"30/10/2009 9:36:25 PM";
      String displayStartDate = displayFormat.format(now.getTime());
      now.add(Calendar.DAY_OF_YEAR, 1);
      String endDate = xmlFormat.format(now.getTime());//"30/11/2009 9:36:25 PM";
      String displayEndDate = displayFormat.format(now.getTime());

      // Create the required Elements for the request
      Element[] elements = new Element[4];
      elements[0] = wsClient.createElement("groupName", group);
      elements[1] = wsClient.createElement("startDate", startDate);
      elements[2] = wsClient.createElement("endDate", endDate);
      elements[3] = wsClient.createElement("includeRecipientDetails", "true");

      // Make the web service request
      Node wsResponse = wsClient.send("FindWhoIsOnDuty", elements);
      Node groupNode = wsResponse.selectSingleNode("ap:return");
      %>

        <table class="duty-report-level1">

          <tr>
            <th class="duty-report-lt-header">Who's on duty for: <%=displayStartDate%> - <%=displayEndDate%></th>
          </tr>

          <%

          %>
          <tr>
            <td>
              <table class="duty-report-level2">
                <tr>
                  <th>Group Name</th>
                  <th>Group Time Zone</th>
                  <th>Supervisors</th>
                </tr>
                <tr>
                  <td class="centered-text"><a href="QuickMessage.jsp?group=<%=getValueOfNode(groupNode, "ap:groupName")%>&operator=<%=request.getParameter("operator")%>"><%=getValueOfNode(groupNode, "ap:groupName")%></a></td>
                  <td class="centered-text"><%=getValueOfNode(groupNode, "ap:groupTimezone/ap:identifier")%> <%=getValueOfNode(groupNode, "ap:groupTimezone/ap:gmtOffset")%></td>
                  <td>
                    <%
                    List supervisorNodes = groupNode.selectNodes("ap:supervisors/ap:supervisor");
                    for(int i = 0; i < supervisorNodes.size(); i++){
                      Node supervisorNode = (Node)supervisorNodes.get(i);
                      %>
                      <a href="QuickMessage.jsp?person=<%=getValueOfNode(supervisorNode, "ap:name")%>&operator=<%=request.getParameter("operator")%>"><%=getValueOfNode(supervisorNode, "ap:name")%></a><br/>
                      <%
                    }
                    %>
                  </td>
                </tr>
                <%
                List scheduleNodes = groupNode.selectNodes("ap:scheduleList/ap:schedule");
                for(int i = 0; i < scheduleNodes.size(); i++){
                  Node scehdule = (Node)scheduleNodes.get(i);
                %>
                  <tr>
                    <td class="no-padding" colspan="4">
                      <table class="duty-report-level3">
                        <tr>
                          <th class="th-left"><%=getValueOfNode(scehdule, "ap:name")%></th>
                          <th class="th-right"></th>
                        </tr>
                        <tr>
                          <td class="no-padding" colspan="2">
                          <table class="duty-report-level4">
                            <tr>
                              <th>Recipient</th>
                              <th>Category</th>
                              <th>Escalation</th>
                            </tr>
                        <%
                        List recipientNodes = scehdule.selectNodes("ap:recipientList/ap:recipient");
                        for(int j = 0; j < recipientNodes.size(); j++){
                          Node recipient = (Node)recipientNodes.get(j);
                        %>
                              <tr>
                                <td><a href="QuickMessage.jsp?person=<%=getValueOfNode(recipient, "ap:targetName")%>&operator=<%=request.getParameter("operator")%>"><%=getValueOfNode(recipient, "ap:targetName")%></a></td>
                                <td><%=getValueOfNode(recipient, "ap:category")%></td>
                                <td><%=getValueOfNode(recipient, "ap:escalation")%></td>
                              </tr>
                              <%
                              }
                              %>
                          </table>
                        </td>
                      </tr>
                    </table>
                  </td>
                  </tr>
                <%
                }
                %>
            </table>

          </td>
          </tr>
      </table>
    <%
    }else{
    %>
      <div class="system-msg-error"><%=errMsg%></div>
    <%
    }
    %>

    <input type="submit" value="Close" onclick="javascript:{self.close();}" />
  </body>
</html>
<% } catch (Exception e) {
  e.printStackTrace(new java.io.PrintWriter(out));
}
%>